<!DOCTYPE html>
<html lang="en">
<head>
  <title>67.S10</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Lesson</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="Lesson-code">ID Lesson</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-ID-code" name="ID" placeholder="ID" disabled
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="Lesson-code">Mã Lesson</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-Lesson-code" name="Lessoncodes" placeholder="Lesson code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="Lesson-code">Tên Lesson</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-Lesson-name" name="Lessonname" placeholder="Lesson name"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="introduce">Giới Thiệu</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-introduce" name="introduce" placeholder="introduce" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="page">Trang</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-page" name="page" placeholder="Trang bao nhiêu..." class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="chapter">Thuộc Chapter</label>
		</div>
		<div class="col-sm-6">
		  <input type="text" id="input-chapter" name="chapter" placeholder="Thuộc Chapter" class="form-control" disabled>
		</div>
		<div class="col-sm-3">
			<button id="btn-show-chapter" class="btn btn-primary">Chi Tiết Chapter</button>
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-12 row mt-4">
			<div class="col-sm-4 text-center">
				<button id="save_data" class="btn btn-info w-50">Save Data</button>
			</div>
			<div class="col-sm-4 text-center">
				<button id="add-new" class="btn btn-success w-50">Thêm Mới</button>
			</div>
			<div class="col-sm-4 text-center">
				<button id="btn_Delete" class="btn btn-danger w-50">Xóa</button>
			</div>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã Lesson</th>
        <th>Tên Lesson</th>
        <th>Giới Thiệu</th>
        <th>Page</th>
        <th>Action</th>
      </tr>
  </table>

   <!-- Modal create lesson-->
   <div class="modal fade" id="myModal-show-Chapter" role="dialog">
    <div class="modal-dialog modal-lg">
    
      <!-- Modal content-->
      <div class="modal-content">
        <div class="modal-header">
			<h4 class="modal-title">Danh Sách Chapter</h4>
          	<button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
			<table class="table table-bordered table-striped table-hover" id="user-table-modal">
				<thead>
				  <tr>
					<th>ID</th>
					<th>Mã Chapter</th>
					<th>Tên Chapter</th>
					<th>Giới Thiệu</th>
					<th>Dịch Giả</th>
					<th>Page</th>
				  </tr>
			  </table>

              <h3 class="text-center text-danger">Hãy Chọn Chapter Muốn Thêm Lesson !!!</h3>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
        </div>
      </div>
      
    </div>
  </div>

   <!-- Modal Chi Tiêt ChapTer-->
   <div class="modal fade" id="myModal-show1-Chapter" role="dialog">
    <div class="modal-dialog modal-lg">
    
      <!-- Modal content-->
      <div class="modal-content">
        <div class="modal-header">
			<h4 class="modal-title text-primary">Thông Tin Chapter</h4>
          	<button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
            <div class="jumbotron container">
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="Chapter-code">ID Chapter</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-ID-code-modal" name="ID" placeholder="ID" disabled
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="Chapter-code">Mã Chapter</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-Chapter-code-modal" name="Chaptercodes" placeholder="Chapter code"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="Chapter-code">Tên Chapter</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-Chapter-name-modal" name="Chaptername" placeholder="Chapter name"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="introduce">Giới Thiệu</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-introduce-modal" name="introduce" placeholder="introduce" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="translator">Dịch Giả</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-translator-modal" name="translator" placeholder="translator" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="page">Trang</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-page-modal" name="page" placeholder="Trang bao nhiêu..." class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="lesson">Số Bài</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-lesson-modal" name="lesson" placeholder="Số Bài" class="form-control" disabled>
                  </div>
                </div>
              </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
        </div>
      </div>
      
    </div>
  </div>
</div>
<script>
	$(document).ready(function(){
		

		//Vùng 1: định nghĩa global variable (biến toàn cục)
		var idLesson = null;
        var gLessonCode = "";
		
		var gObjectLesson = {
			lessonCode : "",
			lessonName : "",
			introduce : "",
			page: "",
		};

		var STT = 0 ;
		var tableModal = $("#user-table-modal").DataTable({
			"columns": [
				{"data": "id"},
				{"data": "chapterCode"},
				{"data": "chapterName"},
				{"data": "introduce"},
				{"data": "translator"},  
				{"data": "page"},
			],
		})

		const ARRAY_COLUM = ["id", "lessonCode", "lessonName", "introduce", "page", "action"]; 
		const ID_COL = 0;
		const CODE_COL = 1;
		const NAME_COL = 2;
		const INTRODUCE_COL = 3;
		const PAGE_COL = 4;
		const ACTION_COL = 5;

		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
		onPageloading();
		// sự kiện load trang
		function onPageloading(){
			$("#btn-show-lesson").hide();
			var table = $("#user-table").DataTable({
			"columns": [
				{"data": ARRAY_COLUM[ID_COL]},
				{"data": ARRAY_COLUM[CODE_COL]},
				{"data": ARRAY_COLUM[NAME_COL]},
				{"data": ARRAY_COLUM[INTRODUCE_COL]},
				{"data": ARRAY_COLUM[PAGE_COL]},
				{"data": ARRAY_COLUM[ACTION_COL]},
			],
			"columnDefs": [
				{ 
                "targets": ACTION_COL , 
                "className": 'text-center',
                "defaultContent":
                  `
                  <button type="button" class="btn btn-link btn-update" id="btn-update"><i class="fas fa-edit"></i></button>
				  <button type="button" class="btn btn-link btn-delete" id="btn-delete"><i class="fas fa-trash-alt"></i></button>
                  `
              	},
				{
                "targets": ID_COL , 
                "render": function () {
					STT ++
					return STT;
					}
              	}
				
			],
		})
		$.ajax({
			url: "http://localhost:8080/api/lessons",
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				table.clear();
				table.rows.add(res);
				table.draw();
			},
			error: function(err){
				console.log(err.response);
			}
		})
	}

		// sự kiện update click
		$("#save_data").on("click", function(){
			updateLessonClick();
		});


		// sự kiện xoa click
		$("#user-table").on("click", ".btn-delete" , function(){
			deleteClick();
		});
		$("#btn_Delete").on("click", deleteClick);

	
		// sự kiện thêm mới click
		$("#add-new").on("click", function(){
			addNewLessonClick();
		});

		// sự kiện show lesson click
		$("#btn-show-lesson").on("click", function(){
			loadDataToInpModalLesson();
			$("#myModal-show-lesson").modal("show");
		});
	
		// Sự kiện click vào dòng trên bảng
		$("#user-table tbody").on("click","tr" , function(){
			onRowClick(this);
		});
		// Sự kiện click vào dòng trên bảng modal
		$("#user-table-modal tbody").on("click","tr" , function(){
			onRowModalClick(this);
		});

        $("#btn-show-chapter").on("click", function(){
            if(idLesson != null){
                $("#myModal-show1-Chapter").modal("show");
                callApiGetChapterByLessonCode();
            }
           
        })

		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		// sự kiện thêm mới
		function addNewLessonClick(){
			console.log("ok")
			// B1 Thu Thap Du Lieu
			readDataAddNewForm(gObjectLesson);
			// B2 Validate
			var vCheck = validateDataForm(gObjectLesson);
			if(vCheck){
                $("#myModal-show-Chapter").modal("show");
                callApiGetAllChapter();
				// callApiAddNewLesson();
			}
			
		}

	
		// Sự Kiện Xóa Lesson
		function deleteClick(){
			"use strict"
			if(idLesson != null){

				
				if (confirm("Bạn chắc chắn muốn xóa không") == true) {
					$.ajax({
					url: "http://localhost:8080/api/lessons/delete/" + idLesson,
					type: 'DELETE',
					success: function(result) {
						alert("Bạn Đã Xóa Thành Công")
							location.reload();
						}
					});
							} else {
							text = "You canceled!";
							}
				}	else{
					alert("Bạn chưa chọn ID");
				}			
		}
		
		// updateLesson click
		function updateLessonClick(){
			if(idLesson != null){
				// B1 Thu Thap Du Lieu
				readDataAddNewForm(gObjectLesson);
				// B2 Validate
				var vCheck = validateDataForm(gObjectLesson);
				if(vCheck){
					callApiUpdateLesson(gObjectLesson);
				}
			}else{
				alert("chưa chọn id muốn sửa");
			}
			
			
		}

		function onRowClick(e){
			var vRowClick = $(e).closest("tr"); // xác định tr chứa nút bấm được click
			var vTable = $("#user-table").DataTable(); // tạo biến truy xuất đến DataTbale
			var vDataRow = vTable.row(vRowClick).data(); // lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
			console.log(vDataRow);
			idLesson = vDataRow.id;
            gLessonCode = vDataRow.lessonCode;
			$("#input-Lesson-code").val(vDataRow.lessonCode);
			$("#input-Lesson-name").val(vDataRow.lessonName);
			$("#input-introduce").val(vDataRow.introduce);
			$("#input-page").val(vDataRow.page);
			$("#input-ID-code").val(vDataRow.id);
            callApiGetChapterByLessonCode();
			// console.log($(e.target).closest("tr").find("td:eq(0)").text())
		}
			//click modal
		function onRowModalClick(e){
            
			var vRowModalClick = $(e).closest("tr"); // xác định tr chứa nút bấm được click
			var vTableModal = $("#user-table-modal").DataTable(); // tạo biến truy xuất đến DataTbale
			var vDataModalRow = vTableModal.row(vRowModalClick).data(); // lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
			console.log(vDataModalRow);
            if(confirm("bạn có chắc chắn chọn chapter này không:  " + vDataModalRow.chapterName) == true){
                callApiAddNewLesson(vDataModalRow.id);
            }
			// console.log($(e.target).closest("tr").find("td:eq(0)").text())
		}
			
		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // lấy danh sách chapter
        function callApiGetAllChapter(){
            $.ajax({
			url: "http://localhost:8080/api/books",
			type: "GET",
            dataType: "Json",
			success: function(res){
                tableModal.clear();
                tableModal.rows.add(res);
                tableModal.draw();
			},
			error: function(err){
				console.log(err.response);
				alert("that bai")
			}
		  })
        }
 
        // Gọi api lấy chapter bằng lesson code
        function callApiGetChapterByLessonCode(){
            $.ajax({
			url: "http://localhost:8080/api/booksBy?lessonCode=" + gLessonCode,
			type: "GET",
            dataType: "Json",
			success: function(res){
                $("#input-chapter").val(res.chapterName);

                $("#input-ID-code-modal").val(res.id);
                $("#input-Chapter-code-modal").val(res.chapterCode);
                $("#input-Chapter-name-modal").val(res.chapterName);
                $("#input-introduce-modal").val(res.introduce);
                $("#input-translator-modal").val(res.translator);
                $("#input-page-modal").val(res.page);
                $("#input-lesson-modal").val(res.lessons.length);
			},
			error: function(err){
				console.log(err.response);
				alert("that bai")
			}
		  })
        }

		//call api update Lesson
		function callApiUpdateLesson(data){
			"use strict";
			console.log(data);
			console.log(idLesson);
			$.ajax({
			url: "http://localhost:8080/api/lessons/update/" + idLesson,
			type: "PUT",
			data: JSON.stringify(data),
			contentType: 'application/json',
			success: function(res){
				alert("Cập nhập Lesson thành công")
				console.log(res);
				location.reload();
			},
			error: function(err){
				console.log(err.response);
				alert("that bai")
			}
		  })
		}

		// thu thap du lieu inp Lesson
		function readDataAddNewForm(data){
			"use strict"
			data.lessonCode = $("#input-Lesson-code").val().trim();
			data.lessonName = $("#input-Lesson-name").val().trim();
			data.introduce = $("#input-introduce").val().trim();
			data.page = $("#input-page").val().trim();
			data.id = $("#input-ID-code").val().trim();

		}
		// Validate du lieu
		function validateDataForm(data){
			"use strict"
			if(data.lessonCode == ""){
				alert("Chưa nhập mã Lesson")
				return false;
			};
			if(data.lessonName == ""){
				alert("Chưa nhập Tên Lesson")
				return false;
			}
			if(data.introduce == ""){
				alert("Chưa nhập introduce Lesson")
				return false;
			}
			if(data.page == ""){
				alert("Chưa nhập page Lesson")
				return false;
			}

			return true ;

		}
			
		//call api add new Lesson
		function callApiAddNewLesson(dataId){
			console.log(gObjectLesson);
			"use strict";
			$.ajax({
			url: "http://localhost:8080/api/lessons/create/" + dataId,
			type: "POST",
			data: JSON.stringify(gObjectLesson),
			contentType: 'application/json',
			success: function(res){
				alert("Thêm Mới Lesson thành công")
				console.log(res);
				location.reload();
			},
			error: function(err){
				console.log(err.response);
				alert("that bai")
			}
		  })
		}
		

		function loadDataToInpModalLesson(){
			"use strict"
			$.ajax({
			url: "http://localhost:8080/api/lessons/" + idLesson,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res.lessons);
				tableModal.clear();
				tableModal.rows.add(res.lessons);
				tableModal.draw();
				$("#modal_h").text(res.LessonName);
			},
			error: function(err){
				console.log(err.response);
			}
		})
		}

	})
</script>
</body>
</html>
